/*
  
  Bibliothèque de liste triée d'entiers
  CMI 

*/

#include <stdlib.h>
#include <stdio.h>


#include "listeEntiers.h"

/********************** Fonctions internes ******************************/

/* Liste d'entiers -- implémentation masquée */

struct Liste {
  int contenu; /* valeur de l'élément */
  Liste suivant; /* suite de la liste */
};


/********************** Fonctions publiques ******************************/

/* Constructeur de Liste (d'un élément) à partir d'un entier */
Liste newListe(int n){
  Liste liste = (Liste) calloc(1,sizeof(struct Liste));

  liste->contenu = n;
  liste->suivant = NULL;
  return liste;
}

/* Destructeur de Liste */
void detruireListe(Liste liste){
  if ( liste != NULL )
    detruireListe(liste->suivant);
  free(liste); /* libération de la mémoire */
}

/* Afficher une liste d'entiers sur une ligne*/
void afficherListe(Liste liste){
  while(liste!=NULL){
    printf("%d ",liste->contenu);
    liste = liste->suivant;
  }
  printf("\n");
}

/* Ajouter un élément à sa place dans la liste triée */
Liste inserer(Liste liste, int val){
  Liste avant,apres;
  Liste tmp = newListe(val);

  if (liste == NULL)
    return tmp;

  avant = NULL;
  apres = liste;
  while( (apres != NULL) && (apres->contenu < val) ){
    avant = apres;
    apres = apres->suivant;
  }
  tmp->suivant = apres;
  if ( avant == NULL )
    return tmp;
  
  avant->suivant = tmp;
  return liste;
}

/* Decaler la liste triée jusqu'aux élément supérieurs à val*/
Liste decaler(Liste liste, int val){
  while( (liste!=NULL) && (liste->contenu <= val)){
    liste = liste->suivant;
  }
  return liste;
}

/* rechercher si la liste triée contient val*/
int rechercher(Liste liste, int val){
  while( (liste!=NULL) && (liste->contenu < val)){
    liste = liste->suivant;
  }
  return ((liste!=NULL) && (liste->contenu == val));
}


  
